// ChildFrm.h : interface of the CChildFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDFRM_H__903546DD_E15E_11D3_AA54_00105A49000B__INCLUDED_)
#define AFX_CHILDFRM_H__903546DD_E15E_11D3_AA54_00105A49000B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define GET_CHILDFRM()	( (CChildFrame*) ( ( (CMDIFrameWnd*) ( AfxGetApp()->m_pMainWnd ) )->MDIGetActive() ) )


typedef enum { eEditPane_None, eEditPane_Tile, eEditPane_Mesh, eEditPane_Moveable, eEditPane_Sprite, eEditPane_Sound } enumEditPaneType;


class CTRViewerView;
class ST_SplitterWnd;


class CChildFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CChildFrame)

public:
	CChildFrame();

	enumEditPaneType	eGetEditPaneType( CWnd** lplpEditView ) const;
	void				vSetEditPaneType( enumEditPaneType ePaneType );

	CWnd*				lpGetToolbox( enumEditPaneType eEditType ) const;
	CTRViewerView*		lpGetMainView() const;

	void				vShowToolbox( bool boShow );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual void ActivateFrame(int nCmdShow);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CChildFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CChildFrame)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:

	void	vShowToolboxPane();

    ST_SplitterWnd*					m_lpMainSplitter;
    ST_SplitterWnd*					m_lpEditSplitter;
	enumEditPaneType				m_eEditPaneType;
	bool							m_boToolboxVisible;
	int								m_iTboxMeshView;
	int								m_iTboxMoveableView;
	int								m_iTboxSpriteView;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDFRM_H__903546DD_E15E_11D3_AA54_00105A49000B__INCLUDED_)
