#include "stdafx.h"

#include "Resource.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "TRViewerDoc.h"
#include "TRViewerView.h"
#include "FileTree.h"
#include "HandleBase.h"
#include "HandleEmpty.h"
#include "EditBase.h"


CHandleBase::CHandleBase(CFileTree* lpTree,CChildFrame* lpChildFrm,enumEditPaneType eEditPane,void* lpData) : 
        m_lpTree(lpTree), m_lpChildFrm(lpChildFrm), m_lpData(lpData), m_hParentItem(NULL), m_boExpanded(false), m_eEditPane( eEditPane )
{
    m_szNodeName[0] = 0;
    m_lpTRFile = lpTree->lpGetTRFile();
}


void    CHandleBase::vCreatePane()
{
	m_lpChildFrm->vSetEditPaneType( m_eEditPane );
}


CEditBase*	CHandleBase::lpGetEditView()
{
	CEditBase*	lpEdit = NULL;
	enumEditPaneType	ePaneType = m_lpChildFrm->eGetEditPaneType( reinterpret_cast<CWnd**>( &lpEdit ) );

	return ePaneType == m_eEditPane ? lpEdit : NULL;
}


void    CHandleBase::vShowEditDialog(bool boCreatePane,TCHAR* lpszNodeName)
{
    lstrcpyn(m_szNodeName,lpszNodeName,256);

    // Need to create the pane ?
    if(boCreatePane)
        {
        // Yes: delete the right pane and recreate it
        vCreatePane();
        }

    // Give to the right pane (the edit/show view) informations about the node
    vEditSetInfo(lpszNodeName);
	
	((CMainFrame*)AfxGetApp()->m_pMainWnd)->vSetToolboxType( false, false );

	// Give the focus back to the treeview so that you can use up / down arrows to walk through the items
	::SetFocus( m_lpChildFrm->lpGetMainView()->m_hWnd );
}


void    CHandleBase::vExpandTree_(HTREEITEM hItem)
{
    bool boAlreadyExpanded = m_boExpanded;

    if(!m_boExpanded)
        {
        m_boExpanded = true;

        m_hParentItem = hItem;

        HTREEITEM hItemDel = m_lpTree->GetChildItem(m_hParentItem);
        CHandleBase*    lpNode = (CHandleBase*) m_lpTree->GetItemData(hItemDel);
        delete lpNode;

        m_lpTree->DeleteItem(hItemDel);
        }

    lstrcpyn(m_szNodeName,(TCHAR*)(LPCTSTR)m_lpTree->GetItemText(hItem),256);

    vExpandTree(boAlreadyExpanded);
}


void    CHandleBase::vSetChanged()
{
    m_lpTree->vSetChanged();
}


void    CHandleBase::vCollapseTree()
{
    if(!m_boExpanded) return;

    m_boExpanded = false;

    HTREEITEM h;
    CString   s;

    INSERT(m_lpTree,h,m_hParentItem,new CHandleEmpty(m_lpTree,m_lpChildFrm))  // Child beneath
}


