#pragma once


#include "MyMath.h"
#include "ftkvc40\3dsftk.h"

typedef DWORD       bitu32;
typedef long        bit32;
typedef WORD        bitu16;
typedef short       bit16;
typedef UCHAR       bitu8;
typedef signed char bit8;

#pragma pack(push,1)


//
// MACROs
//

#define READ_ARRAY(num,typeData,ptrDest)  \
    ptrDest     = new typeData [num];     \
    dwSize = (num) * sizeof(typeData);    \
    memcpy(ptrDest,lpData,dwSize);        \
    lpData += dwSize;                     \


#define READ_ARRAY2(num,typeData,ptrDest,ofsSize)			   \
    ptrDest     = new typeData [num];                                          \
	ZeroMemory(ptrDest,sizeof(typeData) * (num));                              \
	dwSize = sizeof(typeData) - (ofsSize);                                         \
	{ for(DWORD dwI_ = 0; dwI_ < (num); ++dwI_) {                              \
		memcpy(ptrDest + dwI_,lpData, dwSize);				                     \
		lpData += dwSize;														  \
	} }                                                                            \


#define READ_ARRAY_TR(num,typeData,ptrDest,size1,size2)                     \
    ptrDest     = new typeData [num];                                       \
    dwSize = (num) * (m_TRType != TR1_FILE ? sizeof(size2) : sizeof(size1));\
    memcpy(ptrDest,lpData,dwSize);                                          \
    lpData += dwSize;                                                       \


#define READ_ARRAYNUM(typeDataNum,typeData,numDest,ptrDest)               \
    numDest     = *(typeDataNum*) lpData; lpData += sizeof(typeDataNum);  \
    ptrDest     = new typeData [numDest];                                 \
    dwSize = (numDest) * sizeof(typeData);                                \
    memcpy(ptrDest,lpData,dwSize);                                        \
    lpData += dwSize;                                                     \


#define READ_ARRAYNUM2(typeDataNum,typeData,numDest,ptrDest,ofsSize)			   \
    numDest     = *(typeDataNum*) lpData; lpData += sizeof(typeDataNum);           \
    ptrDest     = new typeData [numDest];                                          \
	ZeroMemory(ptrDest,sizeof(typeData) * (numDest));                              \
	dwSize = sizeof(typeData) - (ofsSize);                                         \
	{ for(DWORD dwI_ = 0; dwI_ < (numDest); ++dwI_) {                              \
		memcpy(ptrDest + dwI_,lpData, dwSize);				                     \
		lpData += dwSize;														  \
	} }                                                                            \


#define READ_ARRAYNUM_TR(typeDataNum,typeData,numDest,ptrDest,size1,size2)                                    \
    numDest     = *(typeDataNum*) lpData; lpData += sizeof(typeDataNum);          \
    ptrDest     = new typeData [numDest];                                         \
    dwSize = (numDest) * (m_TRType != TR1_FILE ? sizeof(size2) : sizeof(size1));  \
    memcpy(ptrDest,lpData,dwSize);                                                \
    lpData += dwSize;                                                             \


#define READ_ARRAYNUM_TR2(typeDataNum,typeData,numDest,ptrDest,size1,size2,size3)        \
    numDest     = *(typeDataNum*) lpData; lpData += sizeof(typeDataNum);                                       \
    ptrDest     = new typeData [numDest];                                                                      \
	dwSize = (m_TRType == TR1_FILE) ? sizeof(size1) : (m_TRType == TR4_FILE) ? sizeof(size3) : sizeof(size2);  \
    dwSize = (numDest) * dwSize;                                                                               \
    memcpy(ptrDest,lpData,dwSize);                                                                             \
    lpData += dwSize;                                                                                          \


#define WRITE_ARRAY(num,typeData,ptrSrc)  \
    dwSize = (num) * sizeof(typeData);    \
    memcpy(lpData,ptrSrc,dwSize);         \
    lpData += dwSize;                     \


#define WRITE_ARRAY_TR(num,ptrSrc,size1,size2)                              \
    dwSize = (num) * (m_TRType != TR1_FILE ? sizeof(size2) : sizeof(size1));\
    memcpy(lpData,ptrSrc,dwSize);                                           \
    lpData += dwSize;                                                       \


#define WRITE_ARRAYNUM(typeDataNum,typeData,numSrc,ptrSrc)              \
    * ((typeDataNum*) lpData) = numSrc; lpData += sizeof(typeDataNum);  \
    dwSize = numSrc * sizeof(typeData);                                 \
    memcpy(lpData,ptrSrc,dwSize);                                       \
    lpData += dwSize;                                                   \


#define WRITE_ARRAYNUM2(typeDataNum,typeData,numSrc,ptrSrc,ofsSize)     \
    * ((typeDataNum*) lpData) = numSrc; lpData += sizeof(typeDataNum);  \
    {                                                                   \
    BYTE* lpb = (BYTE*) (ptrSrc);                                       \
    for(DWORD dwI = 0; dwI < (numSrc); dwI++)                           \
        {                                                               \
        memcpy(lpData,lpb,sizeof(typeData) - (ofsSize));                \
        lpData += sizeof(typeData) - (ofsSize);                         \
        lpb += sizeof(typeData);                                        \
        }                                                               \
    }                                                                   \


#define WRITE_ARRAYNUM_TR(typeDataNum,numSrc,ptrSrc,size1,size2)      \
    * ((typeDataNum*) lpData) = numSrc; lpData += sizeof(typeDataNum);         \
    dwSize = numSrc * (m_TRType != TR1_FILE ? sizeof(size2) : sizeof(size1));  \
    memcpy(lpData,ptrSrc,dwSize);                                              \
    lpData += dwSize;                                                          \


#define WRITE_ARRAYNUM_TR2(typeDataNum,numSrc,ptrSrc,size1,size2,size3)                                        \
    * ((typeDataNum*) lpData) = numSrc; lpData += sizeof(typeDataNum);                                         \
	dwSize = (m_TRType == TR1_FILE) ? sizeof(size1) : (m_TRType == TR4_FILE) ? sizeof(size3) : sizeof(size2);  \
    dwSize = numSrc * dwSize;                                                                                  \
    memcpy(lpData,ptrSrc,dwSize);                                                                              \
    lpData += dwSize;                                                                                          \



//
// This class handles a bounding box, represented by its
// two opposite corners
//
class CBoundingBox
{
public:

    // Constructors / destructors
    CBoundingBox() : m_vecBBLo(0), m_vecBBHi(0)         { }
    CBoundingBox(CVect3D vecBBLo, CVect3D vecBBHi) :
        m_vecBBLo(vecBBLo), m_vecBBHi(vecBBHi)          { }

    // Accessors
    const CVect3D&   GetBBLo()                  const   { return m_vecBBLo; }
    const CVect3D&   GetBBHi()                  const   { return m_vecBBHi; }

    // Processors
    void    vSetBB(CVect3D vecBBLo,CVect3D vecBBHi)     { m_vecBBLo = vecBBLo; m_vecBBHi = vecBBHi; }
    void    vSetBBLo(CVect3D vecBBLo)                   { m_vecBBLo = vecBBLo; }
    void    vSetBBHi(CVect3D vecBBHi)                   { m_vecBBHi = vecBBHi; }

    CBoundingBox&   operator=(const CBoundingBox& obj)
    {
    m_vecBBLo = obj.m_vecBBLo;
    m_vecBBHi = obj.m_vecBBHi;

    return *this;
    }

    static void vInterpolate(const CBoundingBox& BB1, const CBoundingBox& BB2, CBoundingBox* lpBBRes, FLOAT fInterpFactor)
    {
    lpBBRes->m_vecBBLo  = BB1.m_vecBBLo * ((FLOAT)1.0 - fInterpFactor) + BB2.m_vecBBLo * fInterpFactor;
    lpBBRes->m_vecBBHi  = BB1.m_vecBBHi * ((FLOAT)1.0 - fInterpFactor) + BB2.m_vecBBHi * fInterpFactor;
    }

    void    vTranslate(CVect3D vecTrans)
    {
    m_vecBBLo += vecTrans; m_vecBBHi += vecTrans;
    }

    void    vEnlarge(CBoundingBox& BB2)
    {
    if(m_vecBBLo[0] > BB2.m_vecBBLo[0]) m_vecBBLo[0] = BB2.m_vecBBLo[0];
    if(m_vecBBLo[1] > BB2.m_vecBBLo[1]) m_vecBBLo[1] = BB2.m_vecBBLo[1];
    if(m_vecBBLo[2] > BB2.m_vecBBLo[2]) m_vecBBLo[2] = BB2.m_vecBBLo[2];
    if(m_vecBBHi[0] < BB2.m_vecBBHi[0]) m_vecBBHi[0] = BB2.m_vecBBHi[0];
    if(m_vecBBHi[1] < BB2.m_vecBBHi[1]) m_vecBBHi[1] = BB2.m_vecBBHi[1];
    if(m_vecBBHi[2] < BB2.m_vecBBHi[2]) m_vecBBHi[2] = BB2.m_vecBBHi[2];
    }

private:

    // Data members
    CVect3D             m_vecBBLo;                      // first corner of the BB
    CVect3D             m_vecBBHi;                      // opposite corner of the BB
};



//
// Base structures
//
typedef struct
{
    bitu8   bRed;
    bitu8   bGreen;
    bitu8   bBlue;
} TR2_COLOR;


typedef struct TR2_COLOR4
{
public:

    bitu8   bRed;
    bitu8   bGreen;
    bitu8   bBlue;
    bitu8   bUnused;

    bool operator==(const TR2_COLOR4& col1)
    {
        return col1.bRed == bRed  &&  col1.bGreen == bGreen  &&  col1.bBlue == bBlue;
    }

    bool operator() (const TR2_COLOR4& col1,const TR2_COLOR4& col2) const
    {
        DWORD dwCol1 = (col1.bRed << 16) + (col1.bGreen << 8) + col1.bBlue;
        DWORD dwCol2 = (col2.bRed << 16) + (col2.bGreen << 8) + col2.bBlue;

        return dwCol1 < dwCol2;
    }

} TR2_COLOR4;


typedef struct
{
    TR2_COLOR   aRGB[256];
} TR2_PALETTE8;


typedef struct
{
    TR2_COLOR4  aRGBA[256];
} TR2_PALETTE16;


typedef struct
{
    bit16   sX;
    bit16   sY;
    bit16   sZ;
} TR2_VERTEX;


typedef struct
{
    bitu16  awVertices[3];  // Index of vertices into an array of TR2_VERTEX structures
    bitu16  wTextureIndex;
	bitu16	wExtraTextureIndex;	// Present only in TR4 mesh objects
} TR2_FACE3;


typedef struct
{
    bitu16  awVertices[4];  // Index of vertices into an array of TR2_VERTEX structures
    bitu16  wTextureIndex;
	bitu16	wExtraTextureIndex;	// Present only in TR4 mesh objects
} TR2_FACE4;


typedef struct
{
    bitu8   abTile[256 * 256];
} TR2_TEXTILE8;


typedef struct
{
    bitu16  awTile[256 * 256];
} TR2_TEXTILE16;


//
// Room structures
//

typedef struct
{
    bit32   lX;             // X-offset of room (world coordinates) always >= 0
    bit32   lZ;             // Z-offset of room (world coordinates) always >= 0
    bit32   lYBottom;       // Lowest point in room (because -Y goes up, lYBottom > lYTop)
    bit32   lYTop;          // Highest point in room (because -Y goes up, lYTop < lYBottom)
} TR2_ROOM_INFO;


typedef struct
{
    TR2_VERTEX  Vertex;     // x/z coordinates are relative to TR2_ROOM_INFO->lX & lZ
    bit16       sLighting1; 
} TR1_VERTEX_ROOM;


typedef struct
{
    TR2_VERTEX  Vertex;     // x/z coordinates are relative to TR2_ROOM_INFO->lX & lZ
    bit16       sLighting1; 
    bitu16      wAttributes;// absent from TR1 file
    bitu16      wLighting2; // absent from TR1 file
} TR2_VERTEX_ROOM;


typedef struct
{
    union
    {
        TR1_VERTEX_ROOM tr1;
        TR2_VERTEX_ROOM tr2;
    };
} TR123_VERTEX_ROOM;

typedef struct
{
    bit16       sVertexIndex;
    bit16       sTextureIndex;
} TR2_ROOM_SPRITE;


typedef struct
{
    bitu16                  wNumVertices;
    TR123_VERTEX_ROOM*      lpVertices;
    bitu16                  wNumRectangles;
    TR2_FACE4*              lpRectangles;
    bitu16                  wNumTriangles;
    TR2_FACE3*              lpTriangles;
    bitu16                  wNumSprites;
    TR2_ROOM_SPRITE*        lpSprites;
}   TR2_ROOM_DATA;


typedef struct
{
    bitu16      wAdjoiningRoom;
    TR2_VERTEX  Normal;
    TR2_VERTEX  Vertices[4];
} TR2_ROOM_PORTAL;


typedef struct
{
    bitu16      wFDIndex;
    bitu16      wBoxIndex;
    bitu8       bRoomBelow;
    bit8        cFloor;
    bitu8       bRoomAbove;
    bit8        cCeiling;
} TR2_ROOM_SECTOR;


typedef struct
{
    bit32       lX;
    bit32       lY;
    bit32       lZ;
    bitu16      wIntensity1;
    bitu32      dwFade1;
} TR1_ROOM_LIGHT;


typedef struct
{
    bit32       lX;
    bit32       lY;
    bit32       lZ;
    bitu16      wIntensity1;
    bitu16      wIntensity2;    // absent from TR1 file
    bitu32      dwFade1;
    bitu32      dwFade2;        // absent from TR1 file
} TR2_ROOM_LIGHT;


typedef struct
{
    bit32       lX;
    bit32       lY;
    bit32       lZ;
    TR2_COLOR	color;
    bitu8		bLightType;
	bitu8		bUnknown;
	bitu8		bIntensity;
	float		fIn, fOut;
	float		fLength;
	float		fCutoff;
	float		X,Y,Z;
} TR4_ROOM_LIGHT;


typedef struct
{
    union
    {
        TR1_ROOM_LIGHT  tr1;
        TR2_ROOM_LIGHT  tr2;
        TR4_ROOM_LIGHT  tr4;
    };
} TR123_ROOM_LIGHT;


typedef struct
{
    bitu32      dwX;
    bitu32      dwY;
    bitu32      dwZ;
    bitu16      wRotation;
    bitu16      wIntensity1;
    bitu16      wObjectId;
} TR1_ROOM_STATICMESH;


typedef struct
{
    bitu32      dwX;
    bitu32      dwY;
    bitu32      dwZ;
    bitu16      wRotation;
    bitu16      wIntensity1;
    bitu16      wIntensity2;    // absent from TR1 file
    bitu16      wObjectId;
} TR2_ROOM_STATICMESH;


typedef struct
{
    union
    {
        TR1_ROOM_STATICMESH tr1;
        TR2_ROOM_STATICMESH tr2;
    };
} TR123_ROOM_STATICMESH;


typedef struct
{
    TR2_ROOM_INFO           RoomInfo;
    TR2_ROOM_DATA           RoomData;
    bitu16                  wNumPortals;
    TR2_ROOM_PORTAL*        lpPortals;
    bitu16                  wNumZSectors;
    bitu16                  wNumXSectors;
    TR2_ROOM_SECTOR*        lpSectorList;
    bit16                   sAmbientIntensity1;
    bit16                   sAmbientIntensity2;
    bit16                   sLightMode;           // TR2 Only
    bitu16                  wNumLights;
    TR123_ROOM_LIGHT*       lpLights;
    bitu16                  wNumStaticMeshes;
    TR123_ROOM_STATICMESH*  lpStaticMeshes;
    bit16                   sAlternateRoom;
    bit16                   sFlags;
    TR2_COLOR               RoomLightColor;       // TR3 Only
} TR123_ROOM;


//
// Mesh structures
//
typedef struct
{
    TR2_VERTEX              Center;
    bit32                   lCollisionSize;
    bit16                   sNumVertices;
    bit16                   sNumNormals;
    bit16                   sNumTexturedRectangles;
    bit16                   sNumTexturedTriangles;
    bit16                   sNumColoredRectangles;
    bit16                   sNumColoredTriangles;
} TR2_MESH;


typedef enum { MESH_LIGHTING_INTERNAL, MESH_LIGHTING_EXTERNAL } enumMeshLighting;


typedef struct
{
    enumMeshLighting    LightingType;
    bit16               sNumData;
    union
    {
        TR2_VERTEX*     lpNormals;
        bit16*          lpLights;
    };
} TR2_MESH_LIGHTING;


typedef struct
{
    TR2_VERTEX              Center;
    bit32                   lCollisionSize;
    bit16                   sNumVertices;
    TR2_VERTEX*             lpVertices;
    TR2_MESH_LIGHTING       Lighting;
    bit16                   sNumTexturedRectangles;
    TR2_FACE4*              lpTexturedRectangles;
    bit16                   sNumTexturedTriangles;
    TR2_FACE3*              lpTexturedTriangles;
    bit16                   sNumColoredRectangles;
    TR2_FACE4*              lpColoredRectangles;
    bit16                   sNumColoredTriangles;
    TR2_FACE3*              lpColoredTriangles;
    float                   fMinX,fMaxX;
    float                   fMinY,fMaxY;
    float                   fMinZ,fMaxZ;
    bool                    boIsDummy;
    bool                    boIntensityAlpha;
} TR123_MESH;


typedef struct
{
    bitu32                  dwFrameOffset;
    bitu8                   bFrameRate;
    bitu8                   bFrameSize;
    bitu16                  wStateId;
    bit16                   Unknown;
    bit16                   sSpeed;
    bitu16                  wAccelLo;
    bit16                   sAccelHi;
	bitu8					Unknown2[8];		// only in TR4
    bitu16                  wFrameStart;
    bitu16                  wFrameEnd;
    bitu16                  wNextAnimation;
    bitu16                  wNextFrame;
    bitu16                  wNumStateChanges;
    bitu16                  wStateChangeOffset;
    bitu16                  wNumAnimCommands;
    bitu16                  wAnimCommand;
} TR2_ANIMATION;


typedef struct
{
    bitu16                  wStateId;
    bitu16                  wNumAnimDispatches;
    bitu16                  wAnimDispatch;
} TR2_STATE_CHANGE;


typedef struct
{
    bit16                   sLow;
    bit16                   sHigh;
    bit16                   sNextAnimation;
    bit16                   sNextFrame;
} TR2_ANIM_DISPATCH;


typedef struct TR2_ANIM_COMMAND
{
    TR2_ANIM_COMMAND(bit16 sVal) { sValue = sVal; }
    TR2_ANIM_COMMAND() { sValue = 0; }
    bit16                   sValue;
} TR2_ANIM_COMMAND;


typedef struct
{
    bit32                   lCoord;
} TR2_MESHTREE;


typedef struct
{
    bitu32                  dwObjectId;
    bitu16                  wNumMeshes;
    bitu16                  wStartingMesh;
    bitu32                  dwMeshTree;
    bitu32                  dwFrameOffset;
    bitu16                  wAnimation;
} TR2_MOVEABLE;


typedef struct
{
    bit16   sMinX,sMaxX;
    bit16   sMinY,sMaxY;
    bit16   sMinZ,sMaxZ;
} TR2_BBOX;

typedef struct
{
    bitu32                  dwObjectId;
    bitu16                  wMesh;
    TR2_BBOX                BoundingBox[2];
    bitu16                  wFlags;
} TR2_STATICMESH;


typedef struct
{
    bitu16                  wTile;
    bitu8                   bX;
    bitu8                   bY;
    bitu16                  wWidth;
    bitu16                  wHeight;
    bit16                   sLeftSide;
    bit16                   sTopSide;
    bit16                   sRightSide;
    bit16                   sBottomSide;
} TR2_SPRITE_TEXTURE;


typedef struct
{
    bit32                   lObjectId;
    bit16                   sNegativeLength;
    bit16                   sOffset;
} TR2_SPRITE_SEQUENCE;


//
// Other structures
//

typedef struct
{
    bit32                   lX;
    bit32                   lY;
    bit32                   lZ;
    bit16                   sRoom;
    bitu16                  wUnknown;
} TR2_CAMERA;


typedef struct
{
	bitu8					Unknown[40];
} TR4_FLYBY_CAMERA;

typedef struct
{
    bit32                   lX;
    bit32                   lY;
    bit32                   lZ;
    bitu16                  wSoundId;
    bitu16                  wFlags;
} TR2_SOUND_SOURCE;


typedef struct
{
    bitu32                  bZMin;
    bitu32                  bZMax;
    bitu32                  bXMin;
    bitu32                  bXMax;
    bit16                   sTrueFloor;
    bit16                   sOverlapIndex;
} TR1_BOX;


typedef struct
{
    bitu8                   bZMin;
    bitu8                   bZMax;
    bitu8                   bXMin;
    bitu8                   bXMax;
    bit16                   sTrueFloor;
    bit16                   sOverlapIndex;
} TR2_BOX;


typedef struct
{
    union
    {
        TR1_BOX         tr1;
        TR2_BOX         tr2;
    };
} TR123_BOX;


typedef struct
{
    bit16                   aId[6];
} TR1_ZONE;


typedef struct
{
    bit16                   aId[10];
} TR2_ZONE;


typedef struct
{
    union
    {
        TR1_ZONE        tr1;
        TR2_ZONE        tr2;
    };
} TR123_ZONE;


typedef struct
{
    bit8                    cXCoordinate;
    bitu8                   bXPixel;
    bit8                    cYCoordinate;
    bitu8                   bYPixel;
} TR2_OBJECT_TEXTURE_VERT;


typedef struct
{
    bitu16                  wAttribute;
    bitu16                  wTile;
    bitu16                  Unknown;	// only in TR4
    TR2_OBJECT_TEXTURE_VERT Vertices[4];
	bitu32					dwXOffset, dwYOffset, dwXSize, dwYSize;	// only in TR4
} TR2_OBJECT_TEXTURE;


typedef struct
{
    bit16                   sObjectId;
    bit16                   sRoom;
    bit32                   lX;
    bit32                   lY;
    bit32                   lZ;
    bit16                   sAngle;
    bit16                   sIntensity1;
    bitu16                  wFlags;
} TR1_ITEM;


typedef struct
{
    bit16                   sObjectId;
    bit16                   sRoom;
    bit32                   lX;
    bit32                   lY;
    bit32                   lZ;
    bit16                   sAngle;
    bit16                   sIntensity1;
    bit16                   sIntensity2;    // absent from TR1 file
    bitu16                  wFlags;
} TR2_ITEM;


typedef struct
{
    union
    {
        TR1_ITEM        tr1;
        TR2_ITEM        tr2;
    };
} TR123_ITEM;


typedef struct
{
    bitu8                   aData[32 * 256];
} TR2_LIGHTMAP;


typedef struct
{
    bit16                   sRotY;
    bit16                   sRotZ;
    bit16                   sRotZ2;
    bit16                   sPosZ;
    bit16                   sPosY;
    bit16                   sPosX;
    bit16                   sUnknown;
    bit16                   sRotX;
	bit8					Unknown[8];
} TR2_CINEMATIC_FRAME;


typedef struct
{
    bit16                   aData[256];
} TR1_SOUNDMAP;


typedef struct
{
    bit16                   aData[370];
} TR2_SOUNDMAP;


typedef struct
{
    union
    {
        TR1_SOUNDMAP    tr1;
        TR2_SOUNDMAP    tr2;
    };
} TR123_SOUNDMAP;

typedef struct
{
    bit16                   sSample;
    bit16                   sVolume;
    bit16                   sUnknown1;
    bit16                   sUnknown2;
} TR2_SOUND_DETAILS;


typedef struct
{
	bitu32	dwUncompSoundLen;
	bitu32	dwSoundLen;
	bitu8*	lpbData;
} TR4_SOUND;


class CTrMvb;
class CTrStatMsh;
class CTrLstSpr;
class CTrSndMgr;
class CTrLstMsh;

typedef std::list<CTrMvb*>      TRListMoveable;
typedef std::list<CTrStatMsh*>  TRListStaticMesh;
typedef std::list<CTrLstSpr*>   TRListSpriteSeq;
typedef std::list<TR123_ITEM*>  TRListItem;

typedef std::vector<TR2_OBJECT_TEXTURE> TRListObjText;

typedef struct
{
    bitu32                  dwTextUncompSize;
    bitu32                  dwTextCompSize;
    bitu8*                  lpbTextData;
} TR4_COMPR_TEXTURE;


//
// File structures
//
typedef struct
{
    // Palettes
    TR2_PALETTE8                    Palette8;
    TR2_PALETTE16                   Palette16;

    // Textiles
    DWORD                           dwNumTextiles;
    TR2_TEXTILE16**                 lplpTextiles16;

    // Rooms
    WORD                            wNumRooms;
    TR123_ROOM*                     lpRooms;
    
    // Behaviours
    DWORD                           dwNumFloorData;
    bitu16*                         lpFloorData;

    // Meshes geometry
    DWORD                           dwNumMeshes;
    TR123_MESH**                    lplpMeshes;
    bitu32                          dwNumMeshPointers;
    bitu32*                         lpMeshPointers;     // Be careful: after loading the level, each entry holds the 
                                                        // INDEX of the mesh (in the lplpMeshes array), NOT its address as
                                                        // it is the case in the TR level !!

    // Meshes animations
    DWORD                           dwNumAnimations;
    TR2_ANIMATION*                  lpAnimations;
    bitu32                          dwNumStateChanges;
    TR2_STATE_CHANGE*               lpStateChanges;
    bitu32                          dwNumAnimDispatches;
    TR2_ANIM_DISPATCH*              lpAnimDispatches;
    bitu32                          dwNumAnimCommands;
    TR2_ANIM_COMMAND*               lpAnimCommands;
    bitu32                          dwNumMeshTrees;
    TR2_MESHTREE*                   lpMeshTrees;
    bitu32                          dwNumFrames;
    bitu16*                         lpFrames;

    // Meshes lists
    bitu32                          dwNumMoveables;
    TR2_MOVEABLE*                   lpMoveables;
    bitu32                          dwNumStaticMeshes;
    TR2_STATICMESH*                 lpStaticMeshes;
    bitu32                          dwNumSpriteSequences;
    TR2_SPRITE_SEQUENCE*            lpSpriteSequences;
    bitu32                          dwNumItems;
    TR123_ITEM*                     lpItems;

    TRListMoveable*                 lpListMoveable;
    TRListStaticMesh*               lpListStaticMesh;
    TRListSpriteSeq*                lpListSpriteSeq;
    TRListItem*                     lpListItem;

    // Textures
    bitu32                          dwNumSpriteTextures;
    TR2_SPRITE_TEXTURE*             lpSpriteTextures;
    bitu32                          dwNumAnimatedTextures;
    bitu16*                         lpAnimatedTextures;
    bitu32                          dwNumObjectTextures;
    TR2_OBJECT_TEXTURE*             lpObjectTextures;

	bitu16							wNumTextNoBump;	// TR4 only
	bitu16							wNumTextInhab;	// TR4 only
	bitu16							wNumTextBump;	// TR4 only
    TR4_COMPR_TEXTURE				Texture1;		// TR4 only 32 bits textures
    TR4_COMPR_TEXTURE				Texture2;		// TR4 only 16 bits textures
    TR4_COMPR_TEXTURE				Texture3;		// TR4 only 32 bits extra texture
	bitu32							dwNumSounds;	// TR4 only num sounds
	TR4_SOUND*						lpSounds;		// TR4 only sound list
	DWORD							dwNumRoomObjText;
	TR2_OBJECT_TEXTURE*				lpRoomObjText;

    TRListObjText*                  lpListUnusedObjText;

    // Sounds
    bitu32                          dwNumSoundSources;
    TR2_SOUND_SOURCE*               lpSoundSources;
    TR123_SOUNDMAP                  SoundMap;
    bitu32                          dwNumSoundDetails;
    TR2_SOUND_DETAILS*              lpSoundDetails;
    bitu32                          dwNumSampleIndices;
    bitu32*                         lpSampleIndices;
    bitu32                          dwNumSamples;       // TR1 only
    bitu8*                          lpSamples;          // TR1 only

    CTrSndMgr*                      lpSndMgr;

    // Cameras
    bitu32                          dwNumCameras;
    TR2_CAMERA*                     lpCameras;
	bitu32							dwNumFlybyCameras;	// TR4 only
	TR4_FLYBY_CAMERA*				lpFlybyCameras;		// TR4 only

    // NPCs
    bitu32                          dwNumBoxes;
    TR123_BOX*                      lpBoxes;
    bitu32                          dwNumOverlaps;
    bitu16*                         lpOverlaps;
    TR123_ZONE*                     lpZones;

    // Other
    TR2_LIGHTMAP                    LightMap;

    bitu32                          dwNumCinematicFrames;
    TR2_CINEMATIC_FRAME*            lpCinematicFrames;

    bitu16                          wNumDemoData;
    bitu8*                          lpDemoData;
} TR123_FILE_STRUCT;


typedef struct
{
	TR123_FILE_STRUCT tr123File;
} TR_FILE;


#pragma pack(pop)

typedef struct
{
    TR123_MESH*         lpMesh;
    DWORD               dwNumTris;
    DWORD               dwStartTriIndex;
    DWORD               dwNumQuads;
    DWORD               dwStartQuadIndex;
    DWORD               dwNumObjText;
    TR2_OBJECT_TEXTURE* lpLstTextCoord;
} INFO_MESH_MAT;

typedef std::list< INFO_MESH_MAT* > LISTMESHMAT;

typedef struct
{
    bool        boUsed;
    DWORD       dwWidth,dwHeight;
    BYTE*       lpbData;
    TCHAR       szTextName[256];
    LISTMESHMAT ListMeshMat;
} INFO_MAT;

typedef std::map< std::string, INFO_MAT* > MATNAME2INFO;


typedef enum enumTRType { TR_UNKNOWN=0, TR1_FILE=1, TR2_FILE=2, TR3_FILE=3, TR4_FILE=4 };

class CFragment;
class CDlgLevelLoad;
class CDlgLevelSave;
class CDlgLevelLS;

//
class CTRFile
{
public:

    CTRFile() : m_TRType(TR_UNKNOWN), m_boTUBFile(false) { ZeroMemory(&m_trFile,sizeof(TR_FILE)); }
    ~CTRFile() { vRelease(); }

    bool        boLoad(TCHAR* lpszFileName);
    bool        boSave(LPCTSTR lpszFileName);
    void        vRelease();

    enumTRType  GetTRType()     { return m_TRType; }
    TR_FILE&    GetTRFile()     { return m_trFile; }
    TCHAR*      lpszGetLevelName() { return m_szFileName; }
    TCHAR*      lpszGetShortLevelName() { return m_szLevelName; }

    bool        boExportMeshTo3DS(TR123_MESH* lpMesh,TCHAR* lpszObjName);
    bool        boImportMeshFrom3DS(CTrLstMsh* lpMsh,TCHAR* lpszObjName,bool boInternalLighting,bool boForTR4);
    static void vComputeMeshExtents(TR123_MESH* lpMesh);
    static void vCopyMesh(TR123_MESH* lpMeshSrc,TR123_MESH* lpMeshDst);
    static void vReleaseMeshMemory(TR123_MESH* lpMesh);
    static void vComputeMeshCollisionSphere(TR123_MESH* lpMesh);
    static void vOptimizeMesh(TR123_MESH* lpMesh);
    static void vInitializeMesh(TR123_MESH* lpMesh,DWORD dwNumVert,DWORD dwNumTrisMap,DWORD dwNumRectMap,bool boInternalLighting,bool boTR3);
    static void vChangeMeshLightingType(TR123_MESH* lpMesh,enumMeshLighting NewLightingType,bool boTR3);
    static void vTranslateMesh(TR123_MESH* lpMesh,bit16 sX,bit16 sY,bit16 sZ,bool boDontModifyMoveables,CTRFile* lpTRFile);
    static BYTE* lpbWriteMesh(TR123_MESH* lpMesh,BYTE* lpData,BYTE* lpbAddrStartMesh,bool boExtraInfos = false);
    static BYTE* lpbReadMesh(TR123_MESH* lpMesh,BYTE* lpData,BYTE* lpbAddrStartMesh,bool boExtraInfos = false);
    static DWORD dwCalcMeshDataSize(TR123_MESH* lpMesh,DWORD dwMeshOffset,bool boExtraInfos = false);
    static bool  boIsMeshIntensityAlpha(TR123_MESH* lpMesh,TR2_OBJECT_TEXTURE* lpOText);
    void		 vSetMeshIntensityAlpha(TR123_MESH* lpMesh,TR2_OBJECT_TEXTURE* lpOText, bool boSet);
    static void  vSetMeshIntensity(TR123_MESH* lpMesh, float fIntensity, bool boTR3);
    static float fCalcMeshAvgIntensity(TR123_MESH* lpMesh,bool boTR3);
    static void  vMeshReverseLighting(TR123_MESH* lpMesh);
    CTrStatMsh*  lpGetStaticMesh(DWORD dwObjId);
    CTrLstSpr*   lpGetSprite(DWORD dwObjId);

    void        vComputeMoveableExtents(TR2_MOVEABLE* lpMoveable,float* lpfMinX,float* lpfMaxX,float* lpfMinY,float* lpfMaxY,float* lpfMinZ,float* lpfMaxZ);
    void        vTranslateMeshInMoveable(TR2_MOVEABLE* lpMoveable,DWORD dwNumMeshToTranslate,bit16 sX,bit16 sY,bit16 sZ,bool boTranslateChildren);
    static void vCopyMoveable(CTRFile* lpTRFileSrc,TR2_MOVEABLE* lpMoveableSrc,CTRFile* lpTRFileDst,TR2_MOVEABLE* lpMoveableDst,bool boKeepMesh0,bool boDontCopyMesh0);
    DWORD       dwGetNumAnimsForMoveable(TR2_MOVEABLE* lpMoveable);
    static void vGetRotAngleForFrame(enumTRType trType,bitu16** lplpFrame,FLOAT& fAngleX,FLOAT& fAngleY,FLOAT& fAngleZ, WORD& wTRAngle1, WORD& wTRAngle2);
    CTrMvb*     lpGetMoveable(DWORD dwObjId);
    void        vMakeSureSoundsAreAvailable();
    static bool boImportMoveableFrom3DS(CTrMvb* lpMvb,TCHAR* lpsz3DSName,bool boInternalLighting,bool boForTR4);

    static void vComputeObjTextureExtents(TR2_OBJECT_TEXTURE* lpObjText,BYTE bNumVertexPerPoly,bool boOffset,
            bit16* lpsMinU, bit16* lpsMinV,bit16* lpsMaxU, bit16* lpsMaxV);

private:

    bool        boParseTRLevel(BYTE* lpData,DWORD dwDataSize,TCHAR* lpszFileName);

	void		vParseGeometry( BYTE* lpData, DWORD dwBytesRead, CDlgLevelLoad& DlgLoad );
    void        vParseTR123File(BYTE*& lpData, CDlgLevelLoad& DlgLoad);
    void        vParseTR4File(BYTE*& lpData, DWORD dwDataSize, CDlgLevelLoad& DlgLoad );

    void        vConvertToTRLevel(CDlgLevelSave& DlgSave, bool boKeepUnusedTextures);
    void        vConvertFromTRLevel(CDlgLevelLS& DlgLoad);

    DWORD       dwCalcGeometryDataSize();
    DWORD       dwCalcLevelTR123DataSize();
    DWORD       dwCalcLevelTR4DataSize( bool boIncludeGeometry = true );

    void		vMakeGeometry(BYTE* lpbData,CDlgLevelSave& DlgSave, DWORD dwOfsProgress = 0);
    BYTE*       lpbMakeTR123Level(DWORD* lpdwDataSize,bool boConvert = true);
    BYTE*       lpbMakeTR4Level(DWORD* lpdwDataSize,bool boConvert = true);

    static DWORD dwGetVersionNumber(enumTRType TRType);
    DWORD       dwReplaceColoredPolys(TR2_PALETTE8& Palette8, TR2_PALETTE16& Palette16);

	static BYTE* lpbReadTR4Mesh(TR123_MESH* lpMesh,BYTE* lpData,BYTE* lpbAddrStartMesh);
    static BYTE* lpbWriteTR4Mesh(TR123_MESH* lpMesh,BYTE* lpData,BYTE* lpbAddrStartMesh);
    static DWORD dwCalcTR4MeshDataSize(TR123_MESH* lpMesh,DWORD dwMeshOffset);
    static void vCopy3DSMeshIntoTRMesh(TR123_MESH* lpMesh,database3ds* db,mesh3ds* lpMesh3ds,DWORD& dwIdxVert,DWORD& dwIdxTriMap,MATNAME2INFO* lpMapMat,bool boForTR4);
    static void vUpdateMeshData(TR123_MESH* lpMesh,DWORD dwIdxTriMap,bool boInternalLighting);
    static void vComputeMeshNormals(TR123_MESH* lpMesh);

    void        vBuildAnimMgrs();

    DWORD       dwCalcRoomDataSize(TR123_ROOM* lpRoom,enumTRType TRType);

    static void vCreateMoveable(database3ds* db,CTrMvb* lpMvb,DWORD dwNumNodes,bool boInternalLighting,MATNAME2INFO* lpMapMat,bool boForTR4);
    static void vCreateMoveableHierarchy(TR2_MESHTREE** lplpMeshTree,DWORD dwNumNodes,long* lpLstParent);
    static DWORD dwCreateParentArray(database3ds* db,long** lplpLstParent,DWORD dwNumNodes,namelist3ds* lpLstNames);

    static void vComputeFaceArrayNormals(TR2_VERTEX* lpLstVertices,vec3* lpLstPtNormals,DWORD dwNumFaces,void* lpArray,bool boQuad);
    static void vCreateMapMaterial(database3ds* db,MATNAME2INFO& MapMat,TCHAR* lpszTexturePath);

	static MMRESULT	dwConvertADPCMToPCM( WAVEFORMATEX& wfxSrc, WAVEFORMATEX& wfxDst, DWORD dwCompressedSize, BYTE* lpbSrc, DWORD& dwUncompressedSize, BYTE* lpbDst );
	static BYTE*	lpbUncompressSound( TR4_SOUND* lpSound, DWORD& dwUncompressedSize );

	BYTE		bFindColor(float fR,float fG,float fB);

    enumTRType      m_TRType;
    TR_FILE         m_trFile;
    TCHAR           m_szFileName[MAX_PATH];
    TCHAR           m_szLevelName[MAX_PATH];
    bool            m_boTUBFile;
};
