#include "stdafx.h"


//----------------------------------------------------------------------------
//
//  Function:   dwCalcRoomDataSize
//
//  Synopsis:   Calculate the data size of a room
//
//  Arguments:  [lpRoom] -- room to calculate the data size
//              [TRType] -- TR type of the level where this room sits
//
//  Return:     Data size of the room
//
//----------------------------------------------------------------------------
DWORD   CTRFile::dwCalcRoomDataSize(TR123_ROOM* lpRoom,enumTRType TRType)
{
    DWORD   dwSize =
        sizeof(TR2_ROOM_INFO)
      + sizeof(bitu32)

      + sizeof(bitu16)
      + lpRoom->RoomData.wNumVertices * ((TRType == TR1_FILE) ? sizeof(TR1_VERTEX_ROOM) : sizeof(TR2_VERTEX_ROOM))
      + sizeof(bitu16)
      + (sizeof(TR2_FACE4) - sizeof(bitu16)) * lpRoom->RoomData.wNumRectangles
      + sizeof(bitu16)
      + (sizeof(TR2_FACE3) - sizeof(bitu16)) * lpRoom->RoomData.wNumTriangles
      + sizeof(bitu16)
      + sizeof(TR2_ROOM_SPRITE) * lpRoom->RoomData.wNumSprites

      + sizeof(bitu16)
      + sizeof(TR2_ROOM_PORTAL) * lpRoom->wNumPortals
      + sizeof(bitu16)
      + sizeof(bitu16)
      + sizeof(TR2_ROOM_SECTOR) * (lpRoom->wNumXSectors * lpRoom->wNumZSectors)
      + sizeof(bit16)
      + ((TRType != TR1_FILE) ? sizeof(bit16) : 0)
      + ((TRType == TR2_FILE) ? sizeof(bit16) : 0)
      + sizeof(bitu16)
      + lpRoom->wNumLights * ((TRType == TR1_FILE) ? sizeof(TR1_ROOM_LIGHT) : (TRType >= TR4_FILE) ? sizeof(TR4_ROOM_LIGHT) : sizeof(TR2_ROOM_LIGHT))
      + sizeof(bitu16)
      + lpRoom->wNumStaticMeshes * ((TRType == TR1_FILE) ? sizeof(TR1_ROOM_STATICMESH) : sizeof(TR2_ROOM_STATICMESH))
      + sizeof(bit16)
      + sizeof(bit16)
      + ((TRType >= TR3_FILE) ? sizeof(TR2_COLOR) : 0);

    return dwSize;
}


