// TlboxMoveableAnim.cpp : implementation file
//

#include "stdafx.h"

#include "trviewer.h"
#include "ChildFrm.h"
#include "HandleBase.h"
#include "HandleMoveable.h"
#include "EditBase.h"
#include "EditMoveable.h"

#include "ToolboxBase.h"
#include "ToolboxItfBase.h"
#include "ToolboxSheet.h"

#include "TlboxMoveableItf.h"
#include "TlboxMoveableAnim.h"

#include "AnimData.h"
#include "AnimKey.h"
#include "AnimTrack.h"
#include "AnimMgr.h"
#include "TRAnimTrack.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTlboxMoveableAnim property page

IMPLEMENT_DYNCREATE(CTlboxMoveableAnim, CPropertyPage)

CTlboxMoveableAnim::CTlboxMoveableAnim( CToolboxBase* lpParent ) : CToolboxItfBase(CTlboxMoveableAnim::IDD, lpParent)
{
	//{{AFX_DATA_INIT(CTlboxMoveableAnim)
	m_cstrCurAnim = _T("");
	m_cstrCurFrame = _T("");
	m_dwAnimFrameRate = 0;
	m_cstrNumTotFrames = _T("");
	m_cstrCurKey = _T("");
	m_cstrNumTotKeys = _T("");
    m_dwAnimSpeed       = 50;
	m_fAnimInterp = 0.0f;
	m_cstrStateId = _T("");
    m_cstrAnmUnk    = _T("");
    m_cstrAnmSpeed  = _T("");
    m_cstrAnmAccel  = _T("");
	m_dwNextAnim = 0;
	m_dwNextFrame = 0;
	//}}AFX_DATA_INIT
    m_boChainAnimations = false;
    m_boAutomaticAnim   = true;
    m_boAnimInterp      = true;
    m_boAnmParamsInHexa = false;
    m_lAnmUnk           = 0;
    m_lAnmSpeed         = 0;
    m_fAnmAccel         = 0.0f;
}

CTlboxMoveableAnim::~CTlboxMoveableAnim()
{
}

void CTlboxMoveableAnim::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTlboxMoveableAnim)
	DDX_Control(pDX, IDC_SLIDERSPEED, m_SliderSpeed);
	DDX_Control(pDX, IDC_SPININTERP, m_SpinInterp);
	DDX_Control(pDX, IDC_SLIDERKEY, m_SliderKey);
	DDX_Control(pDX, IDC_SLIDERFRAME, m_SliderFrame);
	DDX_Control(pDX, IDC_COMBOANIM, m_LstAnims);
	DDX_Text(pDX, IDC_CURANIM, m_cstrCurAnim);
	DDX_Text(pDX, IDC_CURFRAME, m_cstrCurFrame);
	DDX_Text(pDX, IDC_ANIMSPEED, m_dwAnimFrameRate);
	DDX_Text(pDX, IDC_NUMTOTFRAMES, m_cstrNumTotFrames);
	DDX_Text(pDX, IDC_CURKEY, m_cstrCurKey);
	DDX_Text(pDX, IDC_NUMTOTKEYS, m_cstrNumTotKeys);
	DDX_Text(pDX, IDC_ANIMOVERALLSPEED, m_dwAnimSpeed);
	DDX_Text(pDX, IDC_INTERP, m_fAnimInterp);
	DDX_Text(pDX, IDC_MVBSTATEID, m_cstrStateId);
	DDX_Text(pDX, IDC_ANM_PARAM1, m_cstrAnmUnk);
	DDX_Text(pDX, IDC_ANM_PARAM2, m_cstrAnmSpeed);
	DDX_Text(pDX, IDC_ANM_PARAM3, m_cstrAnmAccel);
	DDX_Text(pDX, IDC_MVBNEXTANIM, m_dwNextAnim);
	DDX_Text(pDX, IDC_MVBNEXTFRAME, m_dwNextFrame);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTlboxMoveableAnim, CPropertyPage)
	//{{AFX_MSG_MAP(CTlboxMoveableAnim)
	ON_CBN_SELCHANGE(IDC_COMBOANIM, OnSelchangeComboanim)
	ON_BN_CLICKED(IDC_TYPEANIM, OnTypeanim)
	ON_BN_CLICKED(IDC_ANIMMODE, OnAnimmode)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_INTERPON, OnInterpon)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPININTERP, OnDeltaposSpininterp)
	ON_EN_KILLFOCUS(IDC_INTERP, OnKillfocusInterp)
	ON_BN_CLICKED(IDC_HEXDEC, OnHexdec)
	ON_EN_KILLFOCUS(IDC_ANM_PARAM1, OnKillfocusAnmParam1)
	ON_EN_KILLFOCUS(IDC_ANM_PARAM2, OnKillfocusAnmParam2)
	ON_EN_KILLFOCUS(IDC_ANM_PARAM3, OnKillfocusAnmParam3)
	ON_EN_KILLFOCUS(IDC_MVBNEXTANIM, OnKillfocusNextAnim)
	ON_EN_KILLFOCUS(IDC_MVBNEXTFRAME, OnKillfocusNextFrame)
	ON_EN_KILLFOCUS(IDC_MVBSTATEID, OnKillfocusStateId)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTlboxMoveableAnim message handlers

void	CTlboxMoveableAnim::vInit( bool boNewMoveable )
{
	GET_TLBOXHANDLER( CHandleMoveable );
	GET_TLBOXEDIT( CEditMoveable );

    CString s(_T(""));
    CTrMvb* lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(lpEdit)
        {
        CRect Rect;

        lpEdit->vSetAutomaticAnim(m_boAutomaticAnim);
        lpEdit->vSetAnimInterp(m_boAnimInterp);
        lpEdit->vSetAnimationType(m_boChainAnimations,false);

        lpEdit->GetClientRect(&Rect);
//!!        lpEdit->OnSize(0,Rect.right,Rect.bottom);
        }

    // Set the global parameters of the moveable toolbox
    ((CButton*)GetDlgItem(IDC_ANIMMODE))->SetWindowText(m_boAutomaticAnim ? _T("Automatic") : _T("Manual"));
    ((CButton*)GetDlgItem(IDC_INTERPON))->SetWindowText(m_boAnimInterp ? _T("on") : _T("off"));
    ((CButton*)GetDlgItem(IDC_HEXDEC))->SetWindowText(m_boAnmParamsInHexa ? _T("Hex") : _T("Dec"));
    ((CButton*)GetDlgItem(IDC_TYPEANIM))->SetWindowText(m_boChainAnimations ? _T("Chain") : _T("Loop"));

    // Set the anim controls / parameters
    m_SliderSpeed.SetRange(1,100);

    if( boNewMoveable )
        {
        // Set the parameters only if it's a new moveable. If it is not,
        // the parameters have been already set previously
        m_LstAnims.ResetContent();

        int iIndex = m_LstAnims.AddString(_T("No animation"));
        m_LstAnims.SetItemData(iIndex,-1);
		lpEdit->vSetTextToDisplay("No animation");

        if(lpMoveable)
            {
            // Build the anim list (combo)
            CAnimMgr*   lpAnimMgr = lpMoveable->lpGetAnimMgr();
            DWORD       dwNumAnims = lpAnimMgr->dwGetNumTracks();
            DWORD       dwNumAnim = 0;

            while(dwNumAnims--)
                {
                s.Format(_T("Animation #%.3d"),dwNumAnim + 1);

                iIndex = m_LstAnims.AddString(s);

                m_LstAnims.SetItemData(iIndex, dwNumAnim);

                dwNumAnim++;
                }
            }

        // Initialize anim parameters
        m_cstrCurAnim       = _T("");
        m_cstrCurFrame      = _T("");
        m_cstrNumTotFrames  = _T("");
        m_cstrCurKey        = _T("");
        m_cstrNumTotKeys    = _T("");
        m_cstrStateId       = _T("");
        m_dwAnimFrameRate   = 0;
        m_dwAnimSpeed       = 50;
        m_fAnimInterp       = 0.0f;
        m_cstrAnmUnk        = _T("");
        m_cstrAnmSpeed      = _T("");
        m_cstrAnmAccel      = _T("");
        m_dwNextAnim        = 0;
        m_dwNextFrame       = 0;

        if(lpEdit)
            {
            lpEdit->vSetAnimInterp(0.0f);
            lpEdit->vSetAnimOverallSpeed(m_dwAnimSpeed / 100.0f);
            }

        m_LstAnims.SetCurSel(0);
        m_SliderSpeed.SetPos(m_dwAnimSpeed);
        }

    UpdateData(FALSE);
}


void	CTlboxMoveableAnim::vSetCurAnim(DWORD dwCurAnim)
{
	GET_TLBOXHANDLER( CHandleMoveable );

    DWORD   dwOld = _ttol(m_cstrCurAnim); if(dwOld) dwOld = dwOld - 1;

    if(dwOld == dwCurAnim  &&  m_cstrCurAnim != _T("")) return;

    CString s;

    s.Format(_T("%ld"),dwCurAnim + 1);
    m_cstrCurAnim = s;

    if(!lpHandler) return;

    CTrMvb*         lpMoveable  = lpHandler->GetMoveable();
    CAnimMgr*       lpAnimMgr   = lpMoveable->lpGetAnimMgr();
    CTRAnimTrack*   lpTrack     = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

    lpAnimMgr->vGetNextAnimInfos(m_dwNextAnim,m_dwNextFrame);

    m_dwNextAnim++;
    m_dwNextFrame++;

    s.Format(_T("%ld"),dwCurAnim + 1);
    m_cstrCurAnim = s;

    s.Format(_T("%ld"),lpTrack->dwGetStateId());
    m_cstrStateId = s;

    short sUnknown;

    lpTrack->vGetPlayParams(sUnknown,m_lAnmSpeed,m_fAnmAccel);

    m_lAnmUnk = sUnknown;

    vSetAnimParams();

    UpdateData(FALSE);
}


void	CTlboxMoveableAnim::vSetCurFrame(DWORD dwCurFrame,DWORD dwNumFrames)
{
    CString s;

    s.Format(_T("%ld"),dwCurFrame + 1);
    m_cstrCurFrame = s;

    s.Format(_T("/ %ld"),dwNumFrames);
    m_cstrNumTotFrames = s;

    CWnd* lpWnd = GetDlgItem(IDC_CURFRAME);
    lpWnd->SetWindowText(m_cstrCurFrame);

    lpWnd = GetDlgItem(IDC_NUMTOTFRAMES);
    lpWnd->SetWindowText(m_cstrNumTotFrames);

    m_SliderFrame.SetRange(1,dwNumFrames);
    m_SliderFrame.SetPageSize(1);
    m_SliderFrame.SetPos(dwCurFrame + 1);
}

void	CTlboxMoveableAnim::vSetCurKey(DWORD dwCurKey,DWORD dwNumKeys)
{
    CString s;

    s.Format(_T("%ld"),dwCurKey + 1);
    m_cstrCurKey = s;

    s.Format(_T("/ %ld"),dwNumKeys);
    m_cstrNumTotKeys = s;

    CWnd* lpWnd = GetDlgItem(IDC_CURKEY);
    lpWnd->SetWindowText(m_cstrCurKey);

    lpWnd = GetDlgItem(IDC_NUMTOTKEYS);
    lpWnd->SetWindowText(m_cstrNumTotKeys);

    m_SliderKey.SetRange(1,dwNumKeys);
    m_SliderKey.SetPageSize(1);
    m_SliderKey.SetPos(dwCurKey + 1);
}


void	CTlboxMoveableAnim::vSetInterp(float fInterp)
{
    CString s;

    s.Format(_T("%f"),fInterp);

    CWnd* lpWnd = GetDlgItem(IDC_INTERP);

    lpWnd->SetWindowText(s);
}


void	CTlboxMoveableAnim::vSetAnimationFrameRate(DWORD dwAnimFrameRate)
{
    m_dwAnimFrameRate = dwAnimFrameRate;

    CString s;

    s.Format(_T("%ld"),dwAnimFrameRate);

    CWnd* lpWnd = GetDlgItem(IDC_ANIMSPEED);
    lpWnd->SetWindowText(s);
}


void	CTlboxMoveableAnim::vSetAnimationNextAnim(DWORD dwNextAnim,DWORD dwNextFrame)
{
    m_dwNextAnim    = dwNextAnim + 1;
    m_dwNextFrame   = dwNextFrame + 1;

    UpdateData(FALSE);
}


DWORD   CTlboxMoveableAnim::dwGetCurTrack()
{
    return _ttol(m_cstrCurAnim);
}


void	CTlboxMoveableAnim::OnSelchangeComboanim() 
{
 	GET_TLBOXHANDLER( CHandleMoveable );
	GET_TLBOXEDIT( CEditMoveable );

	CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    int iIndex = m_LstAnims.GetCurSel();

    if(iIndex == -1  ||  !lpMoveable) return;

    lpEdit->vSetAnimation(m_LstAnims.GetItemData(iIndex));

	CString cstrAnimName;

	m_LstAnims.GetLBText(iIndex, cstrAnimName);
    lpEdit->vSetTextToDisplay(cstrAnimName);
}

void	CTlboxMoveableAnim::OnTypeanim() 
{
	GET_TLBOXEDIT( CEditMoveable );

	CButton* lpButton = (CButton*)GetDlgItem(IDC_TYPEANIM);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Loop"))
        {
        lpButton->SetWindowText(_T("Chain"));
        m_boChainAnimations = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Loop"));
        m_boChainAnimations = false;
        }

    if(lpEdit) lpEdit->vSetAnimationType(m_boChainAnimations);

    OnSelchangeComboanim();
}


void	CTlboxMoveableAnim::vSetAnimParams()
{
    CString s;

    m_lAnmUnk = (short)m_lAnmUnk;
    if(m_boAnmParamsInHexa) { s.Format(_T("%.4X"),m_lAnmUnk); s = s.Right(4); } else s.Format(_T("%ld"),m_lAnmUnk);
    m_cstrAnmUnk = s;

    m_lAnmSpeed = (short)m_lAnmSpeed;
    s.Format(_T("%ld"),m_lAnmSpeed);
    m_cstrAnmSpeed = s;

    s.Format(_T("%f"),m_fAnmAccel);
    m_cstrAnmAccel = s;
}


void	CTlboxMoveableAnim::OnKillfocusStateId() 
{
 	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if (lpTrack == NULL) return;

	UpdateData(TRUE);

    lpTrack->vSetStateId( _ttol( m_cstrStateId ) );

    CString s;

    s.Format(_T("%ld"),lpTrack->dwGetStateId());
    m_cstrStateId = s;

    UpdateData( FALSE );
}


void	CTlboxMoveableAnim::OnAnimmode() 
{
	GET_TLBOXEDIT( CEditMoveable );

	CButton* lpButton = (CButton*)GetDlgItem(IDC_ANIMMODE);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Manual"))
        {
        lpButton->SetWindowText(_T("Automatic"));
        m_boAutomaticAnim = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Manual"));
        m_boAutomaticAnim = false;
        }

    if(lpEdit) lpEdit->vSetAutomaticAnim(m_boAutomaticAnim);
}


void	CTlboxMoveableAnim::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	GET_TLBOXEDIT( CEditMoveable );

    CString s;

    int iCtrlId = pScrollBar->GetDlgCtrlID();

    switch(nSBCode)
        {
        case TB_THUMBPOSITION:
        case TB_PAGEDOWN:
        case TB_PAGEUP:
        case TB_THUMBTRACK:
            {
            CSliderCtrl* lpSlider = reinterpret_cast<CSliderCtrl*>(pScrollBar);

            int nPos = lpSlider->GetPos();

            switch(iCtrlId)
                {
                case IDC_SLIDERFRAME:
                    {
                    if(m_boAutomaticAnim) break;
                    lpEdit->vSetAnimCurFrame(nPos - 1);
                    break;
                    }
                case IDC_SLIDERKEY:
                    {
                    if(m_boAutomaticAnim) break;
                    lpEdit->vSetAnimCurKey(nPos - 1);
                    break;
                    }
                case IDC_SLIDERSPEED:
                    {
                    m_dwAnimSpeed = nPos;
                    lpEdit->vSetAnimOverallSpeed(m_dwAnimSpeed / 100.0f);
                    s.Format(_T("%ld"),m_dwAnimSpeed);
                    CWnd* lpWnd = GetDlgItem(IDC_ANIMOVERALLSPEED);
                    lpWnd->SetWindowText(s);
                    break;
                    }
                }
            break;
            }
        }

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


void	CTlboxMoveableAnim::OnInterpon() 
{
	GET_TLBOXEDIT( CEditMoveable );

    CWnd* lpWnd = GetDlgItem(IDC_INTERP);
    lpWnd->SetFocus();

	CButton* lpButton = (CButton*)GetDlgItem(IDC_INTERPON);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("off"))
        {
        lpButton->SetWindowText(_T("on"));
        m_boAnimInterp = true;
        }
    else
        {
        lpButton->SetWindowText(_T("off"));
        m_boAnimInterp = false;
        }

    if(lpEdit) lpEdit->vSetAnimInterp(m_boAnimInterp);
}


void	CTlboxMoveableAnim::OnDeltaposSpininterp(NMHDR* pNMHDR, LRESULT* pResult) 
{
	GET_TLBOXEDIT( CEditMoveable );

    if(m_boAutomaticAnim) return;

	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

    if(lpEdit) lpEdit->vChangeAnimInterp(-pNMUpDown->iDelta > 0 ? 1 : -1);
    	
	*pResult = 0;
}


void	CTlboxMoveableAnim::OnKillfocusInterp() 
{
	GET_TLBOXEDIT( CEditMoveable );

	UpdateData(TRUE);

    if(lpEdit) lpEdit->vSetAnimInterp(m_fAnimInterp);
}


void	CTlboxMoveableAnim::OnHexdec() 
{
	CButton* lpButton = (CButton*)GetDlgItem(IDC_HEXDEC);

    CString cstrTxt;
    
    lpButton->GetWindowText(cstrTxt);

    if(cstrTxt == _T("Dec"))
        {
        lpButton->SetWindowText(_T("Hex"));
        m_boAnmParamsInHexa = true;
        }
    else
        {
        lpButton->SetWindowText(_T("Dec"));
        m_boAnmParamsInHexa = false;
        }

    vSetAnimParams();

    UpdateData(FALSE);
}


void	CTlboxMoveableAnim::OnKillfocusAnmParam1() 
{
 	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if( lpTrack == NULL) return;

	UpdateData(TRUE);

	if(m_boAnmParamsInHexa)
        {
        sscanf(m_cstrAnmUnk,"%x",&m_lAnmUnk);
        lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
        vSetAnimParams();
        UpdateData(FALSE);
        }
    else
        {
        m_lAnmUnk = _ttol(m_cstrAnmUnk);
        lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
        }
}

void	CTlboxMoveableAnim::OnKillfocusAnmParam2() 
{
 	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if( lpTrack == NULL) return;

	UpdateData(TRUE);

    m_lAnmSpeed = _ttol(m_cstrAnmSpeed);
    lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
}

void	CTlboxMoveableAnim::OnKillfocusAnmParam3() 
{
 	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if( lpTrack == NULL) return;

	UpdateData(TRUE);

    m_fAnmAccel = atof(m_cstrAnmAccel);
    lpTrack->vSetPlayParams(m_lAnmUnk,m_lAnmSpeed,m_fAnmAccel);
}


void	CTlboxMoveableAnim::OnKillfocusNextAnim() 
{
 	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if( lpTrack == NULL) return;

	UpdateData(TRUE);

    lpAnimMgr->vSetNextTrack(lpAnimMgr->dwGetCurrentTrack(),m_dwNextAnim - 1,NO_CHANGE);
    lpAnimMgr->vSetChainTracks(m_boChainAnimations);
}


void	CTlboxMoveableAnim::OnKillfocusNextFrame() 
{
 	GET_TLBOXHANDLER( CHandleMoveable );

    CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;

    if(!lpMoveable) return;

    CAnimMgr*       lpAnimMgr = lpMoveable->lpGetAnimMgr();
    DWORD           dwCurAnim = _ttol(m_cstrCurAnim); if(dwCurAnim) dwCurAnim--;
    CTRAnimTrack*   lpTrack = static_cast<CTRAnimTrack*>(lpAnimMgr->lpGetCurrentTrack());

	if( lpTrack == NULL) return;

	UpdateData(TRUE);

    lpAnimMgr->vSetNextTrack(lpAnimMgr->dwGetCurrentTrack(),NO_CHANGE,m_dwNextFrame - 1);
    lpAnimMgr->vSetChainTracks(m_boChainAnimations);
}


bool	CTlboxMoveableAnim::boCheckKeys()
{
 	GET_TLBOXHANDLER( CHandleMoveable );
	GET_TLBOXEDIT( CEditMoveable );

	CTrMvb*   lpMoveable = lpHandler ? lpHandler->GetMoveable() : NULL;
    CAnimMgr* lpAnimMgr = lpMoveable->lpGetAnimMgr();

    bool boCtrled = GetAsyncKeyState(VK_CONTROL) & 0x8001 ? true : false;

    //if(!boCtrled) return false;

    int iIndex = m_LstAnims.GetCurSel();
	int iMax = lpAnimMgr->dwGetNumTracks(); 

    if ((GetAsyncKeyState(VK_F6) & 0x1) && iIndex < iMax)
	{
		m_LstAnims.SetCurSel(iIndex + 1);
		OnSelchangeComboanim();
		return true;
	}

    if ((GetAsyncKeyState(VK_F5) & 0x1) && iIndex > 0)
	{
		m_LstAnims.SetCurSel(iIndex - 1);
		OnSelchangeComboanim();
		return true;
	}

	return false;
}
